/// <reference types="wicg-file-system-access" />
import { Contents, ServerConnection } from '@jupyterlab/services';
import { ISignal } from '@lumino/signaling';
export declare class FileSystemDrive implements Contents.IDrive {
    get isDisposed(): boolean;
    dispose(): void;
    get name(): string;
    get serverSettings(): ServerConnection.ISettings;
    get fileChanged(): ISignal<Contents.IDrive, Contents.IChangedArgs>;
    get rootHandle(): FileSystemDirectoryHandle | null;
    set rootHandle(handle: FileSystemDirectoryHandle | null);
    get(path: string, options?: Contents.IFetchOptions): Promise<Contents.IModel>;
    getDownloadUrl(path: string): Promise<string>;
    newUntitled(options?: Contents.ICreateOptions): Promise<Contents.IModel>;
    delete(path: string): Promise<void>;
    rename(oldPath: string, newPath: string): Promise<Contents.IModel>;
    save(path: string, options?: Partial<Contents.IModel>): Promise<Contents.IModel>;
    copy(path: string, toLocalDir: string): Promise<Contents.IModel>;
    createCheckpoint(path: string): Promise<Contents.ICheckpointModel>;
    listCheckpoints(path: string): Promise<Contents.ICheckpointModel[]>;
    restoreCheckpoint(path: string, checkpointID: string): Promise<void>;
    deleteCheckpoint(path: string, checkpointID: string): Promise<void>;
    private getParentHandle;
    private getHandle;
    private hasHandle;
    private getFileModel;
    private _isDisposed;
    private _fileChanged;
    private _rootHandle;
}
